###BV PICRUSt from qPCR data

options(stringsAsFactors=F)
library(data.table)

kos_from_species = function(qpcr, ref_kos){
  #kos_by_sample=list(NULL) ##kos by ksample and species - have qpcr for 14 species but genomes for only 11 of them
  ref_names = unique(ref_kos[,Name])
  spec_names = names(qpcr)[3:dim(qpcr)[2]]
  kolist=data.table()
  for(j in 1:dim(qpcr)[1]){
    for(i in spec_names){
      #ind=grep(names(qpcr)[i],ref_names,ignore.case=T)
      if(any(grepl(i, ref_names)) & !is.na(unlist(qpcr[j,i,with=F]))){
        amt=as.numeric(qpcr[j,i,with=F]) #amount in that sample
        if(is.na(amt)) amt = 0
	    if(amt>0){
    	    kolist=rbind(kolist, data.table(KO=as.character(ref_kos[Name==i,V1]),Abund=ref_kos[Name==i,V2]*amt/1000, Species=i, Sample=qpcr[j,Sample]))
        	##scale by 1000 to make numbers more manageable
        }
      } #else kos_by_sample[[j]]=NULL
    }
  }
  allkos=unique(kolist[,KO]) ##1917 KOs in these 14 species
  BV_kos = kolist[,sum(Abund),by=list(KO,Sample)]
  BV_kos = dcast.data.table(BV_kos,KO~Sample, value.var="V1")
  return(BV_kos)
}

args = commandArgs(trailingOnly=T)

qpcr_data = fread(args[1])
#qpcr_data[,Sample:=Subject]
#qpcr_data[,Sample:=paste(Subject, Visit, sep = "_")]
#qpcr_data[,Sample:=gsub("-", ".", Sample, fixed=T)]
ref_genomes = fread(args[2])
new_kos = kos_from_species(qpcr_data, ref_genomes)

write.table(new_kos, file=args[3], row.names=F, quote=F, sep = "\t")

